# **********************************************************************
#
# Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************
#
# Ice version 3.5.1
#
# <auto-generated>
#
# Generated from file `ISession.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

import Ice, IcePy
import omero_ModelF_ice
import omero_ServicesF_ice
import omero_System_ice
import omero_Collections_ice

# Included module omero
_M_omero = Ice.openModule('omero')

# Included module omero.model
_M_omero.model = Ice.openModule('omero.model')

# Included module Ice
_M_Ice = Ice.openModule('Ice')

# Included module Glacier2
_M_Glacier2 = Ice.openModule('Glacier2')

# Included module omero.sys
_M_omero.sys = Ice.openModule('omero.sys')

# Included module omero.api
_M_omero.api = Ice.openModule('omero.api')

# Included module omero.grid
_M_omero.grid = Ice.openModule('omero.grid')

# Start of module omero
__name__ = 'omero'

# Start of module omero.api
__name__ = 'omero.api'

if 'ISession' not in _M_omero.api.__dict__:
    _M_omero.api.ISession = Ice.createTempClass()
    class ISession(_M_omero.api.ServiceInterface):
        '''omero.model.Session creation service for OMERO. Access to
all other services is dependent upon a properly created and still
active omero.model.Session.

The session uuid (omero.model.Session#getUuid) can be
considered a capability token, or temporary single use password.
Simply by possessing it the client has access to all information
available to the omero.model.Session.

Note: Both the RMI ome.system.ServiceFactory as well
as the Ice omero.api.ServiceFactory use
omero.api.ISession to acquire a
omero.model.Session. In the Ice case, Glacier2
contacts omero.api.ISession itself and returns a
ServiceFactory remote proxy. From both ServiceFactory
instances, it is possible but not necessary to access
omero.api.ISession.'''
        def __init__(self):
            if Ice.getType(self) == _M_omero.api.ISession:
                raise RuntimeError('omero.api.ISession is an abstract class')

        def ice_ids(self, current=None):
            return ('::Ice::Object', '::omero::api::ISession', '::omero::api::ServiceInterface')

        def ice_id(self, current=None):
            return '::omero::api::ISession'

        def ice_staticId():
            return '::omero::api::ISession'
        ice_staticId = staticmethod(ice_staticId)

        def createSession_async(self, _cb, p, credentials, current=None):
            '''Creates a new session and returns it to the user.

Exceptions:
    ApiUsageException if principal is null
    SecurityViolation if the password check fails'''
            pass

        def createUserSession_async(self, _cb, timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, current=None):
            '''Allows a user to open up another session for him/herself with the given
defaults without needing to re-enter password.'''
            pass

        def createSessionWithTimeout_async(self, _cb, p, timeToLiveMilliseconds, current=None):
            '''Allows an admin to create a Session for the give
omero.sys.Principal.

Arguments:
    principal
Non-null omero.sys.Principal with the
target user's name
    timeToLiveMilliseconds
The time that this omero.model.Session
has until destruction. This is useful to
override the server default so that an initial
delay before the user is given the token will
not be construed as idle time. A value less than
1 will cause the default max timeToLive to be
used; but timeToIdle will be disabled.'''
            pass

        def createSessionWithTimeouts_async(self, _cb, p, timeToLiveMilliseconds, timeToIdleMilliseconds, current=None):
            '''Allows an admin to create a omero.model.Session for
the given omero.sys.Principal.

Arguments:
    principal
Non-null omero.sys.Principal with the
target user's name
    timeToLiveMilliseconds
The time that this omero.model.Session
has until destruction. Setting the value to 0
will prevent destruction unless the session
remains idle.
    timeToIdleMilliseconds
The time that this omero.model.Session
can remain idle before being destroyed. Setting
the value to 0 will prevent idleness based
destruction.'''
            pass

        def getSession_async(self, _cb, sessionUuid, current=None):
            '''Retrieves the session associated with this uuid, updating
the last access time as well. Throws a
RemovedSessionException if not present, or
a SessionTimeoutException if expired.

This method can be used as a Session ping.'''
            pass

        def getReferenceCount_async(self, _cb, sessionUuid, current=None):
            '''Retrieves the current reference count for the given uuid.
Has the same semantics as getSession.'''
            pass

        def closeSession_async(self, _cb, sess, current=None):
            '''Closes session and releases all resources. It is preferred
that all clients call this method as soon as possible to
free memory, but it is possible to not call close, and
rejoin a session later.

The current reference count for the session is returned. If
the session does not exist, -1. If this call caused the
death of the session, then -2.'''
            pass

        def getMyOpenSessions_async(self, _cb, current=None):
            '''Returns a list of open sessions for the current user. The
list is ordered by session creation time, so that the last
item was created last.'''
            pass

        def getMyOpenAgentSessions_async(self, _cb, agent, current=None):
            '''Like getMyOpenSessions but returns only those
sessions with the given agent string.'''
            pass

        def getMyOpenClientSessions_async(self, _cb, current=None):
            '''Like getMyOpenSessions but returns only those
sessions started by official OMERO clients.'''
            pass

        def getInput_async(self, _cb, sess, key, current=None):
            '''Retrieves an entry from the given
omero.model.Session input environment.'''
            pass

        def getOutput_async(self, _cb, sess, key, current=None):
            '''Retrieves an entry from the omero.model.Session
output environment.'''
            pass

        def setInput_async(self, _cb, sess, key, value, current=None):
            '''Places an entry in the given omero.model.Session
input environment.
If the value is null, the key will be removed.'''
            pass

        def setOutput_async(self, _cb, sess, key, value, current=None):
            '''Places an entry in the given omero.model.Session
output environment. If the value is null, the key will be
removed.'''
            pass

        def getInputKeys_async(self, _cb, sess, current=None):
            '''Retrieves all keys in the omero.model.Session input
environment.

Returns:
    a StringSet of keys'''
            pass

        def getOutputKeys_async(self, _cb, sess, current=None):
            '''Retrieves all keys in the omero.model.Session
output environment.'''
            pass

        def getInputs_async(self, _cb, sess, current=None):
            '''Retrieves all inputs from the given
omero.model.Session input environment.'''
            pass

        def getOutputs_async(self, _cb, sess, current=None):
            '''Retrieves all outputs from the given
omero.model.Session input environment.'''
            pass

        def __str__(self):
            return IcePy.stringify(self, _M_omero.api._t_ISession)

        __repr__ = __str__

    _M_omero.api.ISessionPrx = Ice.createTempClass()
    class ISessionPrx(_M_omero.api.ServiceInterfacePrx):

        '''Creates a new session and returns it to the user.

Exceptions:
    ApiUsageException if principal is null
    SecurityViolation if the password check fails'''
        def createSession(self, p, credentials, _ctx=None):
            return _M_omero.api.ISession._op_createSession.invoke(self, ((p, credentials), _ctx))

        '''Creates a new session and returns it to the user.

Exceptions:
    ApiUsageException if principal is null
    SecurityViolation if the password check fails'''
        def begin_createSession(self, p, credentials, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_createSession.begin(self, ((p, credentials), _response, _ex, _sent, _ctx))

        '''Creates a new session and returns it to the user.

Exceptions:
    ApiUsageException if principal is null
    SecurityViolation if the password check fails'''
        def end_createSession(self, _r):
            return _M_omero.api.ISession._op_createSession.end(self, _r)

        '''Creates a new session and returns it to the user.

Exceptions:
    ApiUsageException if principal is null
    SecurityViolation if the password check fails'''
        def createSession_async(self, _cb, p, credentials, _ctx=None):
            return _M_omero.api.ISession._op_createSession.invokeAsync(self, (_cb, (p, credentials), _ctx))

        '''Allows a user to open up another session for him/herself with the given
defaults without needing to re-enter password.'''
        def createUserSession(self, timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, _ctx=None):
            return _M_omero.api.ISession._op_createUserSession.invoke(self, ((timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup), _ctx))

        '''Allows a user to open up another session for him/herself with the given
defaults without needing to re-enter password.'''
        def begin_createUserSession(self, timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_createUserSession.begin(self, ((timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup), _response, _ex, _sent, _ctx))

        '''Allows a user to open up another session for him/herself with the given
defaults without needing to re-enter password.'''
        def end_createUserSession(self, _r):
            return _M_omero.api.ISession._op_createUserSession.end(self, _r)

        '''Allows a user to open up another session for him/herself with the given
defaults without needing to re-enter password.'''
        def createUserSession_async(self, _cb, timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, _ctx=None):
            return _M_omero.api.ISession._op_createUserSession.invokeAsync(self, (_cb, (timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup), _ctx))

        '''Allows an admin to create a Session for the give
omero.sys.Principal.

Arguments:
    principal
Non-null omero.sys.Principal with the
target user's name
    timeToLiveMilliseconds
The time that this omero.model.Session
has until destruction. This is useful to
override the server default so that an initial
delay before the user is given the token will
not be construed as idle time. A value less than
1 will cause the default max timeToLive to be
used; but timeToIdle will be disabled.'''
        def createSessionWithTimeout(self, p, timeToLiveMilliseconds, _ctx=None):
            return _M_omero.api.ISession._op_createSessionWithTimeout.invoke(self, ((p, timeToLiveMilliseconds), _ctx))

        '''Allows an admin to create a Session for the give
omero.sys.Principal.

Arguments:
    principal
Non-null omero.sys.Principal with the
target user's name
    timeToLiveMilliseconds
The time that this omero.model.Session
has until destruction. This is useful to
override the server default so that an initial
delay before the user is given the token will
not be construed as idle time. A value less than
1 will cause the default max timeToLive to be
used; but timeToIdle will be disabled.'''
        def begin_createSessionWithTimeout(self, p, timeToLiveMilliseconds, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_createSessionWithTimeout.begin(self, ((p, timeToLiveMilliseconds), _response, _ex, _sent, _ctx))

        '''Allows an admin to create a Session for the give
omero.sys.Principal.

Arguments:
    principal
Non-null omero.sys.Principal with the
target user's name
    timeToLiveMilliseconds
The time that this omero.model.Session
has until destruction. This is useful to
override the server default so that an initial
delay before the user is given the token will
not be construed as idle time. A value less than
1 will cause the default max timeToLive to be
used; but timeToIdle will be disabled.'''
        def end_createSessionWithTimeout(self, _r):
            return _M_omero.api.ISession._op_createSessionWithTimeout.end(self, _r)

        '''Allows an admin to create a Session for the give
omero.sys.Principal.

Arguments:
    principal
Non-null omero.sys.Principal with the
target user's name
    timeToLiveMilliseconds
The time that this omero.model.Session
has until destruction. This is useful to
override the server default so that an initial
delay before the user is given the token will
not be construed as idle time. A value less than
1 will cause the default max timeToLive to be
used; but timeToIdle will be disabled.'''
        def createSessionWithTimeout_async(self, _cb, p, timeToLiveMilliseconds, _ctx=None):
            return _M_omero.api.ISession._op_createSessionWithTimeout.invokeAsync(self, (_cb, (p, timeToLiveMilliseconds), _ctx))

        '''Allows an admin to create a omero.model.Session for
the given omero.sys.Principal.

Arguments:
    principal
Non-null omero.sys.Principal with the
target user's name
    timeToLiveMilliseconds
The time that this omero.model.Session
has until destruction. Setting the value to 0
will prevent destruction unless the session
remains idle.
    timeToIdleMilliseconds
The time that this omero.model.Session
can remain idle before being destroyed. Setting
the value to 0 will prevent idleness based
destruction.'''
        def createSessionWithTimeouts(self, p, timeToLiveMilliseconds, timeToIdleMilliseconds, _ctx=None):
            return _M_omero.api.ISession._op_createSessionWithTimeouts.invoke(self, ((p, timeToLiveMilliseconds, timeToIdleMilliseconds), _ctx))

        '''Allows an admin to create a omero.model.Session for
the given omero.sys.Principal.

Arguments:
    principal
Non-null omero.sys.Principal with the
target user's name
    timeToLiveMilliseconds
The time that this omero.model.Session
has until destruction. Setting the value to 0
will prevent destruction unless the session
remains idle.
    timeToIdleMilliseconds
The time that this omero.model.Session
can remain idle before being destroyed. Setting
the value to 0 will prevent idleness based
destruction.'''
        def begin_createSessionWithTimeouts(self, p, timeToLiveMilliseconds, timeToIdleMilliseconds, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_createSessionWithTimeouts.begin(self, ((p, timeToLiveMilliseconds, timeToIdleMilliseconds), _response, _ex, _sent, _ctx))

        '''Allows an admin to create a omero.model.Session for
the given omero.sys.Principal.

Arguments:
    principal
Non-null omero.sys.Principal with the
target user's name
    timeToLiveMilliseconds
The time that this omero.model.Session
has until destruction. Setting the value to 0
will prevent destruction unless the session
remains idle.
    timeToIdleMilliseconds
The time that this omero.model.Session
can remain idle before being destroyed. Setting
the value to 0 will prevent idleness based
destruction.'''
        def end_createSessionWithTimeouts(self, _r):
            return _M_omero.api.ISession._op_createSessionWithTimeouts.end(self, _r)

        '''Allows an admin to create a omero.model.Session for
the given omero.sys.Principal.

Arguments:
    principal
Non-null omero.sys.Principal with the
target user's name
    timeToLiveMilliseconds
The time that this omero.model.Session
has until destruction. Setting the value to 0
will prevent destruction unless the session
remains idle.
    timeToIdleMilliseconds
The time that this omero.model.Session
can remain idle before being destroyed. Setting
the value to 0 will prevent idleness based
destruction.'''
        def createSessionWithTimeouts_async(self, _cb, p, timeToLiveMilliseconds, timeToIdleMilliseconds, _ctx=None):
            return _M_omero.api.ISession._op_createSessionWithTimeouts.invokeAsync(self, (_cb, (p, timeToLiveMilliseconds, timeToIdleMilliseconds), _ctx))

        '''Retrieves the session associated with this uuid, updating
the last access time as well. Throws a
RemovedSessionException if not present, or
a SessionTimeoutException if expired.

This method can be used as a Session ping.'''
        def getSession(self, sessionUuid, _ctx=None):
            return _M_omero.api.ISession._op_getSession.invoke(self, ((sessionUuid, ), _ctx))

        '''Retrieves the session associated with this uuid, updating
the last access time as well. Throws a
RemovedSessionException if not present, or
a SessionTimeoutException if expired.

This method can be used as a Session ping.'''
        def begin_getSession(self, sessionUuid, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getSession.begin(self, ((sessionUuid, ), _response, _ex, _sent, _ctx))

        '''Retrieves the session associated with this uuid, updating
the last access time as well. Throws a
RemovedSessionException if not present, or
a SessionTimeoutException if expired.

This method can be used as a Session ping.'''
        def end_getSession(self, _r):
            return _M_omero.api.ISession._op_getSession.end(self, _r)

        '''Retrieves the session associated with this uuid, updating
the last access time as well. Throws a
RemovedSessionException if not present, or
a SessionTimeoutException if expired.

This method can be used as a Session ping.'''
        def getSession_async(self, _cb, sessionUuid, _ctx=None):
            return _M_omero.api.ISession._op_getSession.invokeAsync(self, (_cb, (sessionUuid, ), _ctx))

        '''Retrieves the current reference count for the given uuid.
Has the same semantics as getSession.'''
        def getReferenceCount(self, sessionUuid, _ctx=None):
            return _M_omero.api.ISession._op_getReferenceCount.invoke(self, ((sessionUuid, ), _ctx))

        '''Retrieves the current reference count for the given uuid.
Has the same semantics as getSession.'''
        def begin_getReferenceCount(self, sessionUuid, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getReferenceCount.begin(self, ((sessionUuid, ), _response, _ex, _sent, _ctx))

        '''Retrieves the current reference count for the given uuid.
Has the same semantics as getSession.'''
        def end_getReferenceCount(self, _r):
            return _M_omero.api.ISession._op_getReferenceCount.end(self, _r)

        '''Retrieves the current reference count for the given uuid.
Has the same semantics as getSession.'''
        def getReferenceCount_async(self, _cb, sessionUuid, _ctx=None):
            return _M_omero.api.ISession._op_getReferenceCount.invokeAsync(self, (_cb, (sessionUuid, ), _ctx))

        '''Closes session and releases all resources. It is preferred
that all clients call this method as soon as possible to
free memory, but it is possible to not call close, and
rejoin a session later.

The current reference count for the session is returned. If
the session does not exist, -1. If this call caused the
death of the session, then -2.'''
        def closeSession(self, sess, _ctx=None):
            return _M_omero.api.ISession._op_closeSession.invoke(self, ((sess, ), _ctx))

        '''Closes session and releases all resources. It is preferred
that all clients call this method as soon as possible to
free memory, but it is possible to not call close, and
rejoin a session later.

The current reference count for the session is returned. If
the session does not exist, -1. If this call caused the
death of the session, then -2.'''
        def begin_closeSession(self, sess, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_closeSession.begin(self, ((sess, ), _response, _ex, _sent, _ctx))

        '''Closes session and releases all resources. It is preferred
that all clients call this method as soon as possible to
free memory, but it is possible to not call close, and
rejoin a session later.

The current reference count for the session is returned. If
the session does not exist, -1. If this call caused the
death of the session, then -2.'''
        def end_closeSession(self, _r):
            return _M_omero.api.ISession._op_closeSession.end(self, _r)

        '''Closes session and releases all resources. It is preferred
that all clients call this method as soon as possible to
free memory, but it is possible to not call close, and
rejoin a session later.

The current reference count for the session is returned. If
the session does not exist, -1. If this call caused the
death of the session, then -2.'''
        def closeSession_async(self, _cb, sess, _ctx=None):
            return _M_omero.api.ISession._op_closeSession.invokeAsync(self, (_cb, (sess, ), _ctx))

        '''Returns a list of open sessions for the current user. The
list is ordered by session creation time, so that the last
item was created last.'''
        def getMyOpenSessions(self, _ctx=None):
            return _M_omero.api.ISession._op_getMyOpenSessions.invoke(self, ((), _ctx))

        '''Returns a list of open sessions for the current user. The
list is ordered by session creation time, so that the last
item was created last.'''
        def begin_getMyOpenSessions(self, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getMyOpenSessions.begin(self, ((), _response, _ex, _sent, _ctx))

        '''Returns a list of open sessions for the current user. The
list is ordered by session creation time, so that the last
item was created last.'''
        def end_getMyOpenSessions(self, _r):
            return _M_omero.api.ISession._op_getMyOpenSessions.end(self, _r)

        '''Returns a list of open sessions for the current user. The
list is ordered by session creation time, so that the last
item was created last.'''
        def getMyOpenSessions_async(self, _cb, _ctx=None):
            return _M_omero.api.ISession._op_getMyOpenSessions.invokeAsync(self, (_cb, (), _ctx))

        '''Like getMyOpenSessions but returns only those
sessions with the given agent string.'''
        def getMyOpenAgentSessions(self, agent, _ctx=None):
            return _M_omero.api.ISession._op_getMyOpenAgentSessions.invoke(self, ((agent, ), _ctx))

        '''Like getMyOpenSessions but returns only those
sessions with the given agent string.'''
        def begin_getMyOpenAgentSessions(self, agent, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getMyOpenAgentSessions.begin(self, ((agent, ), _response, _ex, _sent, _ctx))

        '''Like getMyOpenSessions but returns only those
sessions with the given agent string.'''
        def end_getMyOpenAgentSessions(self, _r):
            return _M_omero.api.ISession._op_getMyOpenAgentSessions.end(self, _r)

        '''Like getMyOpenSessions but returns only those
sessions with the given agent string.'''
        def getMyOpenAgentSessions_async(self, _cb, agent, _ctx=None):
            return _M_omero.api.ISession._op_getMyOpenAgentSessions.invokeAsync(self, (_cb, (agent, ), _ctx))

        '''Like getMyOpenSessions but returns only those
sessions started by official OMERO clients.'''
        def getMyOpenClientSessions(self, _ctx=None):
            return _M_omero.api.ISession._op_getMyOpenClientSessions.invoke(self, ((), _ctx))

        '''Like getMyOpenSessions but returns only those
sessions started by official OMERO clients.'''
        def begin_getMyOpenClientSessions(self, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getMyOpenClientSessions.begin(self, ((), _response, _ex, _sent, _ctx))

        '''Like getMyOpenSessions but returns only those
sessions started by official OMERO clients.'''
        def end_getMyOpenClientSessions(self, _r):
            return _M_omero.api.ISession._op_getMyOpenClientSessions.end(self, _r)

        '''Like getMyOpenSessions but returns only those
sessions started by official OMERO clients.'''
        def getMyOpenClientSessions_async(self, _cb, _ctx=None):
            return _M_omero.api.ISession._op_getMyOpenClientSessions.invokeAsync(self, (_cb, (), _ctx))

        '''Retrieves an entry from the given
omero.model.Session input environment.'''
        def getInput(self, sess, key, _ctx=None):
            return _M_omero.api.ISession._op_getInput.invoke(self, ((sess, key), _ctx))

        '''Retrieves an entry from the given
omero.model.Session input environment.'''
        def begin_getInput(self, sess, key, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getInput.begin(self, ((sess, key), _response, _ex, _sent, _ctx))

        '''Retrieves an entry from the given
omero.model.Session input environment.'''
        def end_getInput(self, _r):
            return _M_omero.api.ISession._op_getInput.end(self, _r)

        '''Retrieves an entry from the given
omero.model.Session input environment.'''
        def getInput_async(self, _cb, sess, key, _ctx=None):
            return _M_omero.api.ISession._op_getInput.invokeAsync(self, (_cb, (sess, key), _ctx))

        '''Retrieves an entry from the omero.model.Session
output environment.'''
        def getOutput(self, sess, key, _ctx=None):
            return _M_omero.api.ISession._op_getOutput.invoke(self, ((sess, key), _ctx))

        '''Retrieves an entry from the omero.model.Session
output environment.'''
        def begin_getOutput(self, sess, key, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getOutput.begin(self, ((sess, key), _response, _ex, _sent, _ctx))

        '''Retrieves an entry from the omero.model.Session
output environment.'''
        def end_getOutput(self, _r):
            return _M_omero.api.ISession._op_getOutput.end(self, _r)

        '''Retrieves an entry from the omero.model.Session
output environment.'''
        def getOutput_async(self, _cb, sess, key, _ctx=None):
            return _M_omero.api.ISession._op_getOutput.invokeAsync(self, (_cb, (sess, key), _ctx))

        '''Places an entry in the given omero.model.Session
input environment.
If the value is null, the key will be removed.'''
        def setInput(self, sess, key, value, _ctx=None):
            return _M_omero.api.ISession._op_setInput.invoke(self, ((sess, key, value), _ctx))

        '''Places an entry in the given omero.model.Session
input environment.
If the value is null, the key will be removed.'''
        def begin_setInput(self, sess, key, value, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_setInput.begin(self, ((sess, key, value), _response, _ex, _sent, _ctx))

        '''Places an entry in the given omero.model.Session
input environment.
If the value is null, the key will be removed.'''
        def end_setInput(self, _r):
            return _M_omero.api.ISession._op_setInput.end(self, _r)

        '''Places an entry in the given omero.model.Session
input environment.
If the value is null, the key will be removed.'''
        def setInput_async(self, _cb, sess, key, value, _ctx=None):
            return _M_omero.api.ISession._op_setInput.invokeAsync(self, (_cb, (sess, key, value), _ctx))

        '''Places an entry in the given omero.model.Session
output environment. If the value is null, the key will be
removed.'''
        def setOutput(self, sess, key, value, _ctx=None):
            return _M_omero.api.ISession._op_setOutput.invoke(self, ((sess, key, value), _ctx))

        '''Places an entry in the given omero.model.Session
output environment. If the value is null, the key will be
removed.'''
        def begin_setOutput(self, sess, key, value, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_setOutput.begin(self, ((sess, key, value), _response, _ex, _sent, _ctx))

        '''Places an entry in the given omero.model.Session
output environment. If the value is null, the key will be
removed.'''
        def end_setOutput(self, _r):
            return _M_omero.api.ISession._op_setOutput.end(self, _r)

        '''Places an entry in the given omero.model.Session
output environment. If the value is null, the key will be
removed.'''
        def setOutput_async(self, _cb, sess, key, value, _ctx=None):
            return _M_omero.api.ISession._op_setOutput.invokeAsync(self, (_cb, (sess, key, value), _ctx))

        '''Retrieves all keys in the omero.model.Session input
environment.

Returns:
    a StringSet of keys'''
        def getInputKeys(self, sess, _ctx=None):
            return _M_omero.api.ISession._op_getInputKeys.invoke(self, ((sess, ), _ctx))

        '''Retrieves all keys in the omero.model.Session input
environment.

Returns:
    a StringSet of keys'''
        def begin_getInputKeys(self, sess, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getInputKeys.begin(self, ((sess, ), _response, _ex, _sent, _ctx))

        '''Retrieves all keys in the omero.model.Session input
environment.

Returns:
    a StringSet of keys'''
        def end_getInputKeys(self, _r):
            return _M_omero.api.ISession._op_getInputKeys.end(self, _r)

        '''Retrieves all keys in the omero.model.Session input
environment.

Returns:
    a StringSet of keys'''
        def getInputKeys_async(self, _cb, sess, _ctx=None):
            return _M_omero.api.ISession._op_getInputKeys.invokeAsync(self, (_cb, (sess, ), _ctx))

        '''Retrieves all keys in the omero.model.Session
output environment.'''
        def getOutputKeys(self, sess, _ctx=None):
            return _M_omero.api.ISession._op_getOutputKeys.invoke(self, ((sess, ), _ctx))

        '''Retrieves all keys in the omero.model.Session
output environment.'''
        def begin_getOutputKeys(self, sess, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getOutputKeys.begin(self, ((sess, ), _response, _ex, _sent, _ctx))

        '''Retrieves all keys in the omero.model.Session
output environment.'''
        def end_getOutputKeys(self, _r):
            return _M_omero.api.ISession._op_getOutputKeys.end(self, _r)

        '''Retrieves all keys in the omero.model.Session
output environment.'''
        def getOutputKeys_async(self, _cb, sess, _ctx=None):
            return _M_omero.api.ISession._op_getOutputKeys.invokeAsync(self, (_cb, (sess, ), _ctx))

        '''Retrieves all inputs from the given
omero.model.Session input environment.'''
        def getInputs(self, sess, _ctx=None):
            return _M_omero.api.ISession._op_getInputs.invoke(self, ((sess, ), _ctx))

        '''Retrieves all inputs from the given
omero.model.Session input environment.'''
        def begin_getInputs(self, sess, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getInputs.begin(self, ((sess, ), _response, _ex, _sent, _ctx))

        '''Retrieves all inputs from the given
omero.model.Session input environment.'''
        def end_getInputs(self, _r):
            return _M_omero.api.ISession._op_getInputs.end(self, _r)

        '''Retrieves all inputs from the given
omero.model.Session input environment.'''
        def getInputs_async(self, _cb, sess, _ctx=None):
            return _M_omero.api.ISession._op_getInputs.invokeAsync(self, (_cb, (sess, ), _ctx))

        '''Retrieves all outputs from the given
omero.model.Session input environment.'''
        def getOutputs(self, sess, _ctx=None):
            return _M_omero.api.ISession._op_getOutputs.invoke(self, ((sess, ), _ctx))

        '''Retrieves all outputs from the given
omero.model.Session input environment.'''
        def begin_getOutputs(self, sess, _response=None, _ex=None, _sent=None, _ctx=None):
            return _M_omero.api.ISession._op_getOutputs.begin(self, ((sess, ), _response, _ex, _sent, _ctx))

        '''Retrieves all outputs from the given
omero.model.Session input environment.'''
        def end_getOutputs(self, _r):
            return _M_omero.api.ISession._op_getOutputs.end(self, _r)

        '''Retrieves all outputs from the given
omero.model.Session input environment.'''
        def getOutputs_async(self, _cb, sess, _ctx=None):
            return _M_omero.api.ISession._op_getOutputs.invokeAsync(self, (_cb, (sess, ), _ctx))

        def checkedCast(proxy, facetOrCtx=None, _ctx=None):
            return _M_omero.api.ISessionPrx.ice_checkedCast(proxy, '::omero::api::ISession', facetOrCtx, _ctx)
        checkedCast = staticmethod(checkedCast)

        def uncheckedCast(proxy, facet=None):
            return _M_omero.api.ISessionPrx.ice_uncheckedCast(proxy, facet)
        uncheckedCast = staticmethod(uncheckedCast)

    _M_omero.api._t_ISessionPrx = IcePy.defineProxy('::omero::api::ISession', ISessionPrx)

    _M_omero.api._t_ISession = IcePy.defineClass('::omero::api::ISession', ISession, -1, (), True, False, None, (_M_omero.api._t_ServiceInterface,), ())
    ISession._ice_type = _M_omero.api._t_ISession

    ISession._op_createSession = IcePy.Operation('createSession', Ice.OperationMode.Normal, Ice.OperationMode.Normal, True, None, (), (((), _M_omero.sys._t_Principal, False, 0), ((), IcePy._t_string, False, 0)), (), ((), _M_omero.model._t_Session, False, 0), (_M_omero._t_ServerError, _M_Glacier2._t_CannotCreateSessionException))
    ISession._op_createUserSession = IcePy.Operation('createUserSession', Ice.OperationMode.Normal, Ice.OperationMode.Normal, True, None, (), (((), IcePy._t_long, False, 0), ((), IcePy._t_long, False, 0), ((), IcePy._t_string, False, 0)), (), ((), _M_omero.model._t_Session, False, 0), (_M_omero._t_ServerError, _M_Glacier2._t_CannotCreateSessionException))
    ISession._op_createSessionWithTimeout = IcePy.Operation('createSessionWithTimeout', Ice.OperationMode.Normal, Ice.OperationMode.Normal, True, None, (), (((), _M_omero.sys._t_Principal, False, 0), ((), IcePy._t_long, False, 0)), (), ((), _M_omero.model._t_Session, False, 0), (_M_omero._t_ServerError, _M_Glacier2._t_CannotCreateSessionException))
    ISession._op_createSessionWithTimeouts = IcePy.Operation('createSessionWithTimeouts', Ice.OperationMode.Normal, Ice.OperationMode.Normal, True, None, (), (((), _M_omero.sys._t_Principal, False, 0), ((), IcePy._t_long, False, 0), ((), IcePy._t_long, False, 0)), (), ((), _M_omero.model._t_Session, False, 0), (_M_omero._t_ServerError, _M_Glacier2._t_CannotCreateSessionException))
    ISession._op_getSession = IcePy.Operation('getSession', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0),), (), ((), _M_omero.model._t_Session, False, 0), (_M_omero._t_ServerError,))
    ISession._op_getReferenceCount = IcePy.Operation('getReferenceCount', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0),), (), ((), IcePy._t_int, False, 0), (_M_omero._t_ServerError,))
    ISession._op_closeSession = IcePy.Operation('closeSession', Ice.OperationMode.Normal, Ice.OperationMode.Normal, True, None, (), (((), _M_omero.model._t_Session, False, 0),), (), ((), IcePy._t_int, False, 0), (_M_omero._t_ServerError,))
    ISession._op_getMyOpenSessions = IcePy.Operation('getMyOpenSessions', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (), (), ((), _M_omero.api._t_SessionList, False, 0), (_M_omero._t_ServerError,))
    ISession._op_getMyOpenAgentSessions = IcePy.Operation('getMyOpenAgentSessions', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0),), (), ((), _M_omero.api._t_SessionList, False, 0), (_M_omero._t_ServerError,))
    ISession._op_getMyOpenClientSessions = IcePy.Operation('getMyOpenClientSessions', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (), (), ((), _M_omero.api._t_SessionList, False, 0), (_M_omero._t_ServerError,))
    ISession._op_getInput = IcePy.Operation('getInput', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0), ((), IcePy._t_string, False, 0)), (), ((), _M_omero._t_RType, False, 0), (_M_omero._t_ServerError,))
    ISession._op_getOutput = IcePy.Operation('getOutput', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0), ((), IcePy._t_string, False, 0)), (), ((), _M_omero._t_RType, False, 0), (_M_omero._t_ServerError,))
    ISession._op_setInput = IcePy.Operation('setInput', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0), ((), IcePy._t_string, False, 0), ((), _M_omero._t_RType, False, 0)), (), None, (_M_omero._t_ServerError,))
    ISession._op_setOutput = IcePy.Operation('setOutput', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0), ((), IcePy._t_string, False, 0), ((), _M_omero._t_RType, False, 0)), (), None, (_M_omero._t_ServerError,))
    ISession._op_getInputKeys = IcePy.Operation('getInputKeys', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0),), (), ((), _M_omero.api._t_StringSet, False, 0), (_M_omero._t_ServerError,))
    ISession._op_getOutputKeys = IcePy.Operation('getOutputKeys', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0),), (), ((), _M_omero.api._t_StringSet, False, 0), (_M_omero._t_ServerError,))
    ISession._op_getInputs = IcePy.Operation('getInputs', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0),), (), ((), _M_omero._t_RTypeDict, False, 0), (_M_omero._t_ServerError,))
    ISession._op_getOutputs = IcePy.Operation('getOutputs', Ice.OperationMode.Idempotent, Ice.OperationMode.Idempotent, True, None, (), (((), IcePy._t_string, False, 0),), (), ((), _M_omero._t_RTypeDict, False, 0), (_M_omero._t_ServerError,))

    _M_omero.api.ISession = ISession
    del ISession

    _M_omero.api.ISessionPrx = ISessionPrx
    del ISessionPrx

# End of module omero.api

__name__ = 'omero'

# End of module omero
